Attribute VB_Name = "basGeneral"
Option Explicit

Public Declare Function GetComputerName Lib "kernel32" Alias "GetComputerNameA" (ByVal lpBuffer As String, nSize As Long) As Long
Public Declare Function timeGetTime Lib "winmm.dll" () As Long

Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" (lpVersionInformation As OSVERSIONINFO) As Long
Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type
Public Declare Function AdjustTokenPrivileges Lib "advapi32.dll" (ByVal TokenHandle As Long, ByVal DisableAllPrivileges As Long, NewState As TOKEN_PRIVILEGES, ByVal BufferLength As Long, PreviousState As TOKEN_PRIVILEGES, ReturnLength As Long) As Long
Public Declare Function GetCurrentProcess Lib "kernel32" () As Long
Public Declare Function LookupPrivilegeValue Lib "advapi32.dll" Alias "LookupPrivilegeValueA" (ByVal lpSystemName As String, ByVal lpName As String, lpLuid As LUID) As Long
Public Declare Function OpenProcessToken Lib "advapi32.dll" (ByVal ProcessHandle As Long, ByVal DesiredAccess As Long, TokenHandle As Long) As Long
Public Const ANYSIZE_ARRAY = 1
Public Type LUID
    lowpart As Long
    highpart As Long
End Type
Public Type LUID_AND_ATTRIBUTES
        pLuid As LUID
        Attributes As Long
End Type
Public Type TOKEN_PRIVILEGES
    PrivilegeCount As Long
    Privileges(ANYSIZE_ARRAY) As LUID_AND_ATTRIBUTES
End Type

Public Const EWX_POWEROFF = 8

Public Const EWX_REBOOT = 2

Public Declare Function ExitWindowsEx Lib "user32" (ByVal uFlags As Long, ByVal dwReserved As Long) As Long


Public Sub AdjustToken()
         Const TOKEN_ADJUST_PRIVILEGES = &H20
         Const TOKEN_QUERY = &H8
         Const SE_PRIVILEGE_ENABLED = &H2
         Dim hdlProcessHandle As Long
         Dim hdlTokenHandle As Long
         Dim tmpLuid As LUID
         Dim tkp As TOKEN_PRIVILEGES
         Dim tkpNewButIgnored As TOKEN_PRIVILEGES
         Dim lBufferNeeded As Long

         hdlProcessHandle = GetCurrentProcess()
         OpenProcessToken hdlProcessHandle, (TOKEN_ADJUST_PRIVILEGES Or _
            TOKEN_QUERY), hdlTokenHandle

      ' Get the LUID for shutdown privilege.
         LookupPrivilegeValue "", "SeShutdownPrivilege", tmpLuid

         tkp.PrivilegeCount = 1    ' One privilege to set
         tkp.Privileges(0).pLuid = tmpLuid
         tkp.Privileges(0).Attributes = SE_PRIVILEGE_ENABLED

     ' Enable the shutdown privilege in the access token of this process.
         AdjustTokenPrivileges hdlTokenHandle, False, _
         tkp, Len(tkpNewButIgnored), tkpNewButIgnored, lBufferNeeded

End Sub

Public Function UTrim(ToTrim As String) As String
    Dim Trimmed As String
    Dim Times As Integer
    Trimmed = Trim(ToTrim)
    For Times = Len(Trimmed) To 1 Step -1
        If Asc(Mid(Trimmed, Times, 1)) <> 0 Then Exit For
    Next Times
    Trimmed = Left(Trimmed, Times)
    UTrim = Trimmed
End Function

Public Function ComputerName() As String
    Dim CN As String * 35
    Dim CNL As Long
    CNL = 35
    GetComputerName CN, CNL
    ComputerName = Left(CN, CNL)
End Function

Public Function ExactWinVer() As String
    Dim VerInfo As OSVERSIONINFO
    Dim VerString As String
    VerInfo.dwOSVersionInfoSize = Len(VerInfo)
    GetVersionEx VerInfo
    With VerInfo
        Select Case .dwMajorVersion
            Case 4
                Select Case .dwMinorVersion
                    Case 0
                        Select Case .dwBuildNumber
                            Case Is < 1000
                                VerString = "Windows 95"
                            Case Is > 1000
                                VerString = "Windows NT4"
                            Case Else
                                VerString = "Windows 4"
                        End Select
                    Case 10
                        Select Case .dwBuildNumber
                            Case Is < 2000
                                VerString = "Windows 98"
                            Case Is > 2000
                                VerString = "Windows 98SE"
                        End Select
                    Case 90
                        VerString = "Windows Me"
                    Case Else
                        VerString = "Windows 4"
                End Select
            Case 5
                Select Case .dwMinorVersion
                    Case 0
                        VerString = "Windows 2000"
                    Case 1
                        VerString = "Widnows XP"
                    Case 2
                        VerString = "Windows Server 2003"
                    Case Else
                        VerString = "Windows 5"
                End Select
            Case 6
                VerString = "Windows Code Name " & Chr(34) & "Longhorn" & Chr(34)
            Case Else
                VerString = "Windows"
        End Select
    End With
    ExactWinVer = VerString & " " & UTrim(VerInfo.szCSDVersion)
End Function
